Subject: Re: netconsole not working on bridge+atlantic

From: Jakub Kicinski <[email-masked]>
Date: Mon, 22 May 2023 18:37:21 -0700

On Fri, 19 May 2023 22:09:24 -0500 Chris Adams wrote:
> Once upon a time, Florian Fainelli <[email-masked]> said:
> > On 5/19/2023 5:38 PM, Chris Adams wrote:  
> > >I have a system with an Aquantia AQC107 NIC connected to a bridge (for
> > >VM NICs).  I set up netconsole on it, and it logs that it configures
> > >correctly in dmesg, but it doesn't actually send anything (or log any
> > >errors).  Any ideas?  
> > 
> > It does not look like there is a ndo_poll_controller callback
> > implemented by the atlantic driver which is usually a prerequisite
> > to supporting netconsole.  

I don't think ndo_poll_controller is strictly necessary any more.
If absent core will poll all NAPI instances of the driver with budget
of 0.

> Is that something that netconsole (or anything else in the kernel) could
> check and warn about?  Is there a way other than looking at the source
> (and knowing what to look for) to tell which NICs do or don't support
> netconsole?  I searched around and didn't see that netconsole is only
> expected to work with some NICs, or has certain requirements for
> working.
> 
> > >This is on Fedora 37, updated to distro kernel 6.3.3-100.fc37.x86_64.
> > >It hasn't worked for some time (not sure exactly when).  
> > 
> > Does that mean that it worked up to a certain point and then stopped?  
> 
> I'm not sure, I didn't check it for a while (I only use it when
> something isn't working right, and that doesn't happen much).  It's
> possible it hasn't worked since I added the Aquantia NIC.

You can try to use the kfree_skb tracepoint to see where the netcons
skbs get dropped.